	.file "blowfishopt.gas.i386.s"

	.text

	.macro  etworounds	p # bp in %ebp, xl and xr in %ecx and %edx, %eax and %ebx clear
	xorl 0+\p(%ebp),%ecx
	roll $16,%ecx
	movb %ch,%al
	movb %cl,%bl
	roll $16,%ecx
	movl 0x000+72(%ebp,%eax,4),%esi
	addl 0x400+72(%ebp,%ebx,4),%esi
	movb %ch,%al
	movb %cl,%bl
	xorl 0x800+72(%ebp,%eax,4),%esi
	addl 0xC00+72(%ebp,%ebx,4),%esi
	xorl %esi,%edx
	xorl 4+\p(%ebp),%edx
	roll $16,%edx
	movb %dh,%al
	movb %dl,%bl
	roll $16,%edx
	movl 0x000+72(%ebp,%eax,4),%esi
	addl 0x400+72(%ebp,%ebx,4),%esi
	movb %dh,%al
	movb %dl,%bl
	xorl 0x800+72(%ebp,%eax,4),%esi
	addl 0xC00+72(%ebp,%ebx,4),%esi
	xorl %esi,%ecx
	.endm

	.macro  dtworounds	p # bp in %ebp, xl and xr in %ecx and %edx, %eax and %ebx clear
	xorl 4+\p(%ebp),%ecx
	roll $16,%ecx
	movb %ch,%al
	movb %cl,%bl
	roll $16,%ecx
	movl 0x000+72(%ebp,%eax,4),%esi
	addl 0x400+72(%ebp,%ebx,4),%esi
	movb %ch,%al
	movb %cl,%bl
	xorl 0x800+72(%ebp,%eax,4),%esi
	addl 0xC00+72(%ebp,%ebx,4),%esi
	xorl %esi,%edx
	xorl 0+\p(%ebp),%edx
	roll $16,%edx
	movb %dh,%al
	movb %dl,%bl
	roll $16,%edx
	movl 0x000+72(%ebp,%eax,4),%esi
	addl 0x400+72(%ebp,%ebx,4),%esi
	movb %dh,%al
	movb %dl,%bl
	xorl 0x800+72(%ebp,%eax,4),%esi
	addl 0xC00+72(%ebp,%ebx,4),%esi
	xorl %esi,%ecx
	.endm

	.align	4
	.globl	blowfishEncrypt
	.type	blowfishEncrypt,@function

blowfishEncrypt:
	# parameter one is the blowfish parameters; need to extract bp and set it up in ebp
	pushl %esi
	pushl %ebp
	pushl %ebx
	# interleave loads
	movl 16(%esp),%ebp # ebp now contains bp
	movl 20(%esp),%esi # esi now contains bl
	# clear eax and ebx
	xorl %eax,%eax
	xorl %ebx,%ebx
	# load xl and xr
	movl 0(%esi),%ecx
	movl 4(%esi),%edx
	bswap %ecx
	bswap %edx
	etworounds p= 0
	etworounds p= 8
	etworounds p=16
	etworounds p=24
	etworounds p=32
	etworounds p=40
	etworounds p=48
	etworounds p=56
	# now the final xor and swap
	movl 20(%esp),%esi
	xorl 64(%ebp),%ecx
	xorl 68(%ebp),%edx
	bswap %ecx
	bswap %edx
	movl %ecx,4(%esi)
	movl %edx,0(%esi)
	# zero return value, restore stack and return
	xorl %eax,%eax
	popl %ebx
	popl %ebp
	popl %esi
	ret

	.align	4
	.globl	blowfishDecrypt
	.type	blowfishDecrypt,@function

blowfishDecrypt:
	# parameter one is the blowfish parameters; need to extract bp and set it up in ebp
	pushl %esi
	pushl %ebp
	pushl %ebx
	# interleave loads
	movl 16(%esp),%ebp # ebp now contains bp
	movl 20(%esp),%esi # esi now contains bl
	# clear eax and ebx
	xorl %eax,%eax
	xorl %ebx,%ebx
	# load xl and xr
	movl 0(%esi),%ecx
	movl 4(%esi),%edx
	bswap %ecx
	bswap %edx
	dtworounds p=64
	dtworounds p=56
	dtworounds p=48
	dtworounds p=40
	dtworounds p=32
	dtworounds p=24
	dtworounds p=16
	dtworounds p= 8
	# now the final xor and swap
	movl 20(%esp),%esi
	xorl 4(%ebp),%ecx
	xorl 0(%ebp),%edx
	bswap %ecx
	bswap %edx
	movl %ecx,4(%esi)
	movl %edx,0(%esi)
	# zero return value, restore stack and return
	xorl %eax,%eax
	popl %ebx
	popl %ebp
	popl %esi
	ret
