#
# Copyright (c) 1998,1999,2000 Virtual Unlimited B.V.
#
# Author: Bob Deblier <bob@virtualunlimited.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

	.file "mp32opt.gas.i386.s"

	.macro	mp32zero_core loop
	leal -4(%edi,%ecx,4),%edi
	xorl %eax,%eax
	p2align 4,,7
\loop:
	movl %eax,(%edi)
	leal -4(%edi),%edi
	decl %ecx
	jnz \loop
	.endm

	.macro	mp32copy_core loop
	decl %ecx
	p2align 4,,7
\loop:
	movl (%esi,%ecx,4),%eax
	movl %eax,(%edi,%ecx,4)
	decl %ecx
	jnz \loop
	.endm

	.macro	mp32addw_core loop end
	leal -4(%edi,%ecx,4),%edi
	addl %eax,(%edi)
	decl %ecx
	jz \end
	leal -4(%edi),%edi
	xorl %edx,%edx
	.p2align 4,,7
\loop:
	adcl %edx,(%edi)
	leal -4(%edi),%edi
	decl %ecx
	jnz \loop
\end:
	.endm

	.macro	mp32subw_core loop end
	leal -4(%edi,%ecx,4),%edi
	subl %eax,(%edi)
	decl %ecx
	jz \end
	leal -4(%edi),%edi
	xorl %edx,%edx
	.p2align 4,,7
\loop:
	sbbl %edx,(%edi)
	leal -4(%edi),%edi
	decl %ecx
	jnz \loop
\end:
	.endm

	.align	4
	.globl	mp32addw
	.type	mp32addw,@function

mp32addw:
	pushl %edi
	movl 8(%esp),%ecx
	movl 12(%esp),%edi
	movl 16(%esp),%eax

	mp32addw_core loop=.L0, end=.L1

	sbbl %eax,%eax
	negl %eax
	popl %edi
	ret

	.align	4
	.globl	mp32subw
	.type	mp32subw,@function

mp32subw:
	pushl %edi
	movl 8(%esp),%ecx
	movl 12(%esp),%edi
	movl 16(%esp),%eax

	mp32subw_core loop=.L2, end=.L3

	sbbl %eax,%eax
	negl %eax
	popl %edi
	ret

	.macro	mp32add_core loop end
	xorl %edx,%edx
	decl %ecx
	.p2align 4,,7
\loop:
	movl (%esi,%ecx,4),%eax
	adcl %eax,(%edi,%ecx,4)
	decl %ecx
	jns \loop
	.endm

	.macro	mp32sub_core loop
	xorl %edx,%edx
	decl %ecx
	.p2align 4,,7
\loop:
	movl (%esi,%ecx,4),%eax
	sbbl %eax,(%edi,%ecx,4)
	decl %ecx
	jns \loop
	.endm

	.align	4
	.globl	mp32add
	.type	mp32add,@function

mp32add:
	pushl %edi
	pushl %esi
	movl 12(%esp),%ecx
	movl 16(%esp),%edi
	movl 20(%esp),%esi

	mp32add_core loop=.L4

	sbbl %eax,%eax
	negl %eax
	popl %esi
	popl %edi
	ret

	.align	4
	.globl	mp32sub
	.type	mp32sub,@function

mp32sub:
	pushl %edi
	pushl %esi
	movl 12(%esp),%ecx
	movl 16(%esp),%edi
	movl 20(%esp),%esi

	mp32sub_core loop=.L5

	sbbl %eax,%eax
	negl %eax
	popl %esi
	popl %edi
	ret

	.macro	mp32divtwo_core
	.endm

	.macro	mp32multwo_core loop
	decl %ecx
	clc
	.p2align 4,,7
\loop:
	rcll $1,(%edi,%ecx,4)
	decl %ecx
	jns \loop
	.endm

	.macro	mp32setmul_core amul, loop
	decl %ecx
	xorl %ebx,%ebx
	.p2align 4,,7
\loop:
	movl (%esi,%ecx,4),%eax
	mull \amul
	addl %ebx,%eax
	adcl $0,%edx
	movl %eax,(%edi,%ecx,4)
	movl %edx,%ebx
	decl %ecx
	jns \loop
	.endm

	.align	4
	.globl	mp32setmul
	.type	mp32setmul,@function

mp32setmul:
	pushl %ebx
	pushl %edi
	pushl %esi
	movl 16(%esp),%ecx
	movl 20(%esp),%edi
	movl 24(%esp),%esi

	mp32setmul_core amul=28(%esp), loop=.L6

	movl %ebx,%eax
	popl %esi
	popl %edi
	popl %ebx
	ret

	.macro mp32addmul_core amul, loop
	decl %ecx
	xorl %ebx,%ebx
	.p2align 4,,7
\loop:
	movl (%esi,%ecx,4),%eax
	mull \amul
	addl %ebx,%eax
	adcl $0,%edx
	addl %eax,(%edi,%ecx,4)
	adcl $0,%edx
	movl %edx,%ebx
	decl %ecx
	jns \loop
	.endm

	.align	4
	.globl	mp32addmul
	.type	mp32addmul,@function

mp32addmul:
	pushl %ebx
	pushl %edi
	pushl %esi
	movl 16(%esp),%ecx
	movl 20(%esp),%edi
	movl 24(%esp),%esi

	mp32addmul_core amul=28(%esp), loop=.L7

	movl %ebx,%eax
	popl %esi
	popl %edi
	popl %ebx
	ret

#	consider doing mp32sqrtrc also
#	.align	4
#	.globl	mp32sqrtrc
#	.type	mp32sqrtrc,@function
#
#mp32sqrtrc:
#	ret
#
#	consider doing mp32mul also
#	.align	4
#	.globl	mp32mul
#	.type	mp32mul,@function
#
#mp32mul:
#	pushl %ebx
#	pushl %edi
#	pushl %esi
#
#	popl %esi
#	popl %edi
#	popl %ebx
#	ret
